using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI;
namespace ClassLibraryWebpartEditor
{
    public class SimpleLabelWebpart : WebPart
    {
        private int _intFontSize;
        private string _strLblData = "";
        
        [Personalizable(PersonalizationScope.Shared),
        WebBrowsable(false),
        WebDisplayName("Personalize your Label data"),
        WebDescription("This label is a personalized webpart")]
        public string LabelData
        {
            get { return _strLblData; }
            set {_strLblData = value; }
        }
        [Personalizable(PersonalizationScope.Shared),
        WebBrowsable(false),
        WebDisplayName("Customize font size for every one"),
        WebDescription("This label is a customized webpart")]
        public int FontSizeValue
        {
            get{ return _intFontSize; }
            set{_intFontSize = value; }
        }
        protected override void CreateChildControls()
        {
            SetPersonalizationDirty();
            base.CreateChildControls();
            Label lbl = new Label();
            lbl.Font.Size = _intFontSize;
            lbl.Text = _strLblData;
            this.Controls.Add(lbl);

        }
        public override EditorPartCollection CreateEditorParts()
        {
            List<EditorPart> editorParts = new List<EditorPart>(1);
            EditorPart part = new SimpleLabelWebPartEditor();
            part.ID = this.ID + "Label Editor";
            editorParts.Add(part);
            EditorPartCollection baseParts = base.CreateEditorParts();
            return new EditorPartCollection(baseParts, editorParts);

        }
    }

    public class SimpleLabelWebPartEditor : EditorPart
    {
        TextBox txtFontsize;
        Label lblFontSizeDescription;
        TextBox txtLabelValue;
        Label lbldescription;
        protected override void CreateChildControls()
        {
            txtFontsize = new TextBox();
            txtLabelValue = new TextBox();
            lblFontSizeDescription = new Label();
            lblFontSizeDescription.Text = "Enter Font Size";
            lbldescription = new Label();
            lbldescription.Text = "Enter Label text";
            this.Controls.Add(lblFontSizeDescription);
            this.Controls.Add(new LiteralControl("<br>"));
            this.Controls.Add(txtFontsize);
            this.Controls.Add(new LiteralControl("<br>"));
            this.Controls.Add(lbldescription);
            this.Controls.Add(new LiteralControl("<br>"));
            this.Controls.Add(txtLabelValue);
        }
        public override void SyncChanges()
        {
            this.EnsureChildControls();
            SimpleLabelWebpart objLbl = (SimpleLabelWebpart) this.WebPartToEdit;
            txtLabelValue.Text = objLbl.LabelData;
            txtFontsize.Text = objLbl.FontSizeValue.ToString();
        }
        public override bool ApplyChanges()
        {
            this.EnsureChildControls();
            SimpleLabelWebpart objLbl = (SimpleLabelWebpart)this.WebPartToEdit;
            objLbl.FontSizeValue = Convert.ToInt16(txtFontsize.Text);
            objLbl.LabelData = txtLabelValue.Text;
            return true;
            
        }
    }

}
